"""
///
/// b_gen.py
///
/// Author:
///   Woo-Kyoung Noh (rainlood@kldp.org)
///
/// (C) 2001 Woo-Kyoung Noh  http://gnome.or.kr/~rainlood/
///
///
///
///
/// <summary>
/// boinda generator
/// </summary>
"""


import sys, glob, os
from b_xml import BoindaXml
from b_item import BoindaItem


class BoindaGen:
	def __init__(self, what='*'):
		#sys.stdin.read()
		files=glob.glob(what)
		bXml = BoindaXml()
		lItem=[]
		try:
		
			lItem, sTemplate = bXml.getIndexAndTemplate(url='index.xml')
		except Exception, e: # UnicodeError, e:
			files=[`e`]
			lItem=[{}]
		#lItem.append({'url':'index.xml'})
		for dItem in lItem:
			item = BoindaItem(dItem)
			if item('url') in files[:]:
				files.remove(item('url'))
		self.files=files
		self.lItem = lItem

	def get(self):
		r=''
		if not self.lItem:
			r=r+"""\
<?xml version="1.0"?>
<index>
"""
		for filename in self.files:
			if os.path.isdir(filename):
				if not os.path.isfile(os.path.join(filename,'index.xml')):
					continue
			elif filename=='index.xml':
					continue
			r=r+"""
<item url="%s">
</item>
"""%filename
		if not self.lItem:
			r=r+"""
<item>
  <title></title>
  <desc><![CDATA[
]]></desc>
</item>
"""
		if not self.lItem:
			r=r+"""
</index>"""
		return r


if __name__ == '__main__':
	from b_test import unittest, BoindaTest
	class BoindaGenTestCase(unittest.TestCase):
		def setUp(self):
			self.bGen = BoindaGen()

		def checkEqual(self):
			assert 1==1

	if len(sys.argv)==2:
		what=sys.argv[1]
		# python b_gen.py '*.py'
	else:
		what='*'
	gen = BoindaGen(what)
	print gen.get()

	#BoindaTest ( BoindaGenTestCase )
