"""
///
/// b_modpython.py
///
/// Author:
///   Woo-Kyoung Noh (rainlood@kldp.org)
///
/// (C) 2001 Woo-Kyoung Noh  http://gnome.or.kr/~rainlood/
///
///
///
///
/// <summary>
/// boinda modpython
/// </summary>
"""

import sys, os, string

# /etc/apache/httpd.conf
"""
<Directory /home/staff/rainlood/public_html>
AddHandler python-program .xml
PythonHandler b_modpython
PythonDebug On
Options Indexes
PythonPath sys.path+['/home/staff/rainlood/public_html/projects/boinda']
</Directory>
"""

from b_index import BoindaIndex
from b_setup import BOINDA_SYSTEMROOT
from b_setup import BOINDA_SERVER_HOST, BOINDA_SERVER_PORT
from b_setup import BOINDA_ONTEST
from b_setup import BOINDA_MODPYTHON_WEBROOT



def handler(req):
	from mod_python import apache, util
	sysstdout=sys.stdout
	sys.stdout=req

	sSystemRoot=BOINDA_SYSTEMROOT
	sWebRoot=BOINDA_MODPYTHON_WEBROOT

	sPath= req.filename[len(sSystemRoot):]
	if sPath[-9:]=='index.xml':
		req.content_type = "text/html"
		req.send_http_header()

		dQuery={}
		for x in util.FieldStorage(req).list:
		  dQuery[x.name]=x.value
		if BOINDA_ONTEST:
			import b_index
			reload(b_index)
			BoindaIndex = b_index.BoindaIndex
		bIndex = BoindaIndex(sSystemRoot, sWebRoot, sPath, dQuery)
		print bIndex.getResponse()
	else:
		req.send_http_header()
		print open(os.path.join(sSystemRoot,sPath)).read()

	sys.stdout=sysstdout
	return apache.OK


if __name__ == '__main__':
	from b_test import unittest, BoindaTest
	class BoindaModpythonTestCase(unittest.TestCase):
		def setUp(self):
			self.modpython = handler

		def checkEqual(self):
			assert 1==1

	BoindaTest ( BoindaModpythonTestCase )
